begin
  require 'faker'
  @have_faker = true
rescue LoadError
  @have_faker = false
end

desc "Create a fake certificate request"
task :fakecsr, :count do |t, args|
  alt_names = ARGV.include? "alt_names"
  if alt_names
    task :alt_names do; end
  end

  count = (args[:count] || 20).to_i

  def openssl(cn, alt=nil)
    if alt
      system("SAN='DNS:#{alt}' openssl req -config /etc/ssl/openssl_altnames.cnf -new -key /etc/puppetlabs/puppet/ssl/private_keys/master.vagrant.internal.pem -subj '/CN=#{cn}' -out request.csr")
    else
      system("openssl req -new -key /etc/puppetlabs/puppet/ssl/private_keys/master.vagrant.internal.pem -subj '/CN=#{cn}' -out request.csr")
    end
  end

  def random_name
    if @have_faker
      Faker::Internet.user_name + "." + Faker::Internet.domain_name
    else
      "example_" + rand(100000).to_s
    end
  end

  count.times do
    cn = random_name
    alt = alt_names ? random_name : nil
    openssl(cn, alt)
    system("curl -k -X PUT -H 'Content-Type: text/plain' --data-binary @request.csr https://33.33.33.10:8140/production/certificate_request/#{cn}")
  end

end
