define(['sandbox', '../collections/requests', './requests', 'text!../templates/base.html', 'dom'],
  function(sandbox, RequestsCollection, RequestsView, template){

  var Application = sandbox.mvc.Layout({

    template: template,

    regions: {
      requests_container: '#certificates-list-container'
    },

    ui: {
      loading_message: '#certificates-loading-message'
    },

    initialize: function(options) {
      sandbox.io.load_stylesheet('../applications/certificates/css/certificates.css');

      this.requests = options.requests || new RequestsCollection;

      this.bindTo(this.requests, 'reset', this.show_list, this);

      this.requests_view = new RequestsView({
        collection: this.requests
      });

    },

    show_list: function() {
      this.ui.loading_message.hide();

      this.requests_container.show(this.requests_view);
    }

  });

  return Application;

});
